import { CssClassList } from '../../utilities/css';
import { colours } from '../../css/colours/';
import { toggle } from '../../css/form/toggle/';

export interface IToggleProps {
  /**
   * if set to true, the toggle will be on
   *  default: false
   * @type {boolean}
   */
  checked?: boolean;
  /**
   * Toggle's on background colour
   *  default: 'blue'
   * @type {string}
   */
  color?: string;
  /**
   * A callback invoked when the user toggles on/off
   * @type {Function}
   */
  onChange?: any;
}

export class Toggle extends React.Component<IToggleProps, {}> {
  public render() {
    let _css = new CssClassList(toggle.toggle);
    _css.add(toggle[this.props.color || colours.blue]);
    return (
      <label className={_css.toString()}>
        <input type="checkbox" checked={this.props.checked} onChange={this.props.onChange}/>
        <span className={toggle.toggle__toggle}></span>
        <span className={toggle.text}>{this.props.children}</span>
      </label>
    )
  }
}
