import { wrapper } from '../../css/wrapper/';
import { CssClassList } from '../../utilities/css';

export interface IWrapperProps {
  /**
   * wrapper's size
   *  available sizes:
   *    'tight'
   *    'wide'
   *    'wrapper'
   * @type {string}
   */
  size?: string;
}

export class Wrapper extends React.Component<IWrapperProps, any> {
  public render() {
    let _css = new CssClassList(wrapper.wrapper);
    if (this.props.size) _css.add(wrapper[this.props.size]);
    return (
      <div className={_css.toString()}>{this.props.children}</div>
    )
  }
}
