import { pushNotifications } from '../../css/notifications/push-notifications/';
import { CssClassList } from '../../utilities/css';

export interface IPushNotificationsProps {
  /**
   * the position for the popup
   */
  position?: string;
  /**
   * Adds styles to the component
   */
  style?: React.CSSProperties;
}

export class PushNotifications extends React.Component<IPushNotificationsProps, any> {
  public render() {
    let css = new CssClassList(pushNotifications.pushNotifications);

    if (this.props.position) css.add(pushNotifications[this.props.position] || pushNotifications.bottomLeft);

    return (
      <section style={this.props.style}>
        {this.props.children}
      </section>
    )
  }
}
